using System;
//ǉO
using System.Net;
using System.Text;
//Win32_NetworkAdapterConfiguration
using System.Management;
//UdpClient
using System.Net.Sockets;
//RNGCryptoServiceProvider
using System.Security.Cryptography;

namespace Qsend
{
	/// <summary>
	/// MX ̊Tv̐łB
	/// </summary>
	public class MX
	{
		struct MXS
		{
			public int p;
			public string ms;
		}
		public MX()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		public string GetMX(string DomainName)
		{
			string DNShost = GetDNS();
			if(DNShost==null)
				return "LocalDnsErr";
			byte[] receivebuffer = new byte[512];
			
			string[] s = DomainName.Split('.');

			//hC̒
			int domain_length = 0;
			foreach(string ss in s)
			{
				domain_length += ss.Length;
				domain_length ++;
			}

			//Mobt@pӂ
			byte[] sendbuffer = new byte[16 + (++domain_length)];

			//wb_\
			byte[] id = MakeID(2);
			Array.Copy(id,sendbuffer,2);
			sendbuffer[2] = 0x01;
			sendbuffer[3] = 0x00;

			sendbuffer[4] = 0x00;
			sendbuffer[5] = 0x01;

			sendbuffer[6] = 0x00;
			sendbuffer[7] = 0x00;

			sendbuffer[8] = 0x00;
			sendbuffer[9] = 0x00;

			sendbuffer[10] = 0x00;
			sendbuffer[11] = 0x00;

			//╔
			int index = 12;
			foreach(string tmp in s)
			{
				sendbuffer[index++] = (byte)tmp.Length;
				Encoding.ASCII.GetBytes(tmp,0,tmp.Length,sendbuffer,index);
				index += tmp.Length;
			}
			sendbuffer[index++] = 0x00;

			sendbuffer[index++] = 0x00;
			sendbuffer[index++] = 0x0F;

			sendbuffer[index++] = 0x00;
			sendbuffer[index++] = 0x01;

			//M
			UdpClient UdpC = new UdpClient();
			IPEndPoint IPE = new IPEndPoint(IPAddress.Parse(DNShost),53);
			try
			{
				UdpC.Connect(IPE);
				UdpC.Send(sendbuffer,index);
				receivebuffer = UdpC.Receive(ref IPE);
				UdpC.Close();
			}
			catch
			{
				return "NetworkErr";
			}

			//Mf[^̃fR[_
			
			//萔
			int Qcount = GetValue(receivebuffer,4,2);
			if(Qcount == 0)
				return null;

			//񓚐
			int Acount = GetValue(receivebuffer,6,2);
			if(Acount == 0)
				return "NoAnswer";

			MXS[] myMX = new MXS[Acount];
			index = 12;


			//╔XLbv
			while(receivebuffer[index] != 0x00)
			{
				index ++;
			}
			index ++;
			index +=4;


			//񓚕i\[XR[hjɓ
			int offset = 0;
			int count =0;
			int Rlength = 0;
			for(int jj=0; jj<Acount; jj++)
			{
				//NAMEXLbv
				while(true)
				{
					if(receivebuffer[index] >= 0xC0)
					{
						index += 2;
						break;
					}
					else if(receivebuffer[index] == 0x00)
					{
						index ++;
						break;
					}
					index++;
				}
						
				//TYPE(2), CLASS(2), TTL(4)@v8oCgXLbv
				index += 8;

				//\[X̒擾
				Rlength = GetValue(receivebuffer,index,2);
				index += 2;
				offset = index;

				//MXR[hPreferenceo
				myMX[count].p = GetValue(receivebuffer,offset,2);

				offset += 2;

				//MXR[h擾
				while(true)
				{
					if(receivebuffer[offset] == 0x00)
						break;
					if(receivebuffer[offset] >= 0xC0)
					{
						offset = GetValue(receivebuffer,offset,2) & 0x3FFF;
					}
					else
					{
						int labelLength = receivebuffer[offset++];
						myMX[count].ms += Encoding.ASCII.GetString(receivebuffer,offset,labelLength);
						myMX[count].ms += ".";
						offset += labelLength;
					}
				}
				//̃R[hֈړ
				index += Rlength;
				count ++;
			}

			//PreferenceŏMXo
			string mx = String.Empty;
			if(count == 1)
			{
				//hCŌ" . "iȂĂnjj
				return myMX[0].ms.Substring(0,myMX[0].ms.Length-1);
				/*
				 *  myMX[0].ms = myMX[0].ms.TrimEnd('.');
				*/
			}
			else
			{
				for(int y=0; y<count-1; y++)
				{
					if(myMX[y].p <= myMX[y+1].p)
					{
						mx = myMX[y].ms;
						continue;
					}
					else
					{
						mx = myMX[y+1].ms;
					}
				}            
				return mx.Substring(0,mx.Length-1);
			}
		}
		/// <summary>
		/// [JzXg̃ftHgDNS擾
		/// </summary>
		/// <returns></returns>
		private string GetDNS()
		{
			ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration");
			string[] DNSSet;
			string DNShost = null;
			try
			{
				foreach(ManagementObject mo in mc.GetInstances())
				{
					if((bool)mo["IPEnabled"])
					{
						DNSSet = (string[])mo["DNSServerSearchOrder"];
						if(DNSSet != null)
						{
							DNShost = DNSSet[0];
						}
					}
				}
				return DNShost;
			}
			catch
			{
				return null;
			}
		}
		private byte[] MakeID(int rndsize)
		{
			byte[] bb = new byte[rndsize];
			RNGCryptoServiceProvider rnd = new RNGCryptoServiceProvider();
			rnd.GetNonZeroBytes(bb);
			return bb;
		}
		/// <summary>
		/// Ⴄo[WGetValue()\bh
		/// </summary>
		/// <param name="inputbytes"></param>
		/// <param name="pos"></param>
		/// <param name="data_length"></param>
		/// <returns></returns>
		private int GetValue(byte[] inputbytes, int pos, int data_length)
		{
			byte[] bb = new byte[data_length];
			int j = 0;
			for(int i=pos; i<pos+data_length; i++)
			{
				bb[j] = inputbytes[i];
				j++;
			}
			if(data_length<=2)
			{
				return IPAddress.NetworkToHostOrder(BitConverter.ToInt16(bb,0));
			}
			else
			{
				return IPAddress.NetworkToHostOrder(BitConverter.ToInt32(bb,0));
			}
		}
	}
}
