//****************************//
//                            //
//  POP3Checker Ver:sample1.0 //
//  Copyright: Sam Zhao       //
//  2005 Niigata City Japan   //
//                            //
//****************************//
using System;
using System.Net.Sockets;
//Encoding
using System.Text;
//StreamReader
using System.IO;

namespace POP3Checker
{
	/// <summary>
	/// POPConnection ̊Tv̐łB
	/// </summary>
	public class POPConnection
	{
		public POPConnection()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		private TcpClient tcpC;
		private NetworkStream netStream;
		private string CRLF = "\r\n";

		/// <summary>
		/// POP3T[o
		/// </summary>
		private string hostname = "127.0.0.1";
		public string HostName
		{
			get{return hostname;}
			set{hostname = value;}
		}

		/// <summary>
		/// POP3T[rX|[g
		/// </summary>
		private int port = 110;
		public int Port
		{
			get{return port;}
			set{port = value;}
		}

		/// <summary>
		/// POPzXgɐڑ
		/// </summary>
		/// <param name="infoMsg"></param>
		/// <returns></returns>
		public bool Connect(out string infoMsg)
		{
			infoMsg = "";
			try
			{
				tcpC = new TcpClient(hostname,port);
				netStream = tcpC.GetStream();
				infoMsg = "T[oɐڑ܂";
				return true;
			}
			catch(Exception ee)
			{
				infoMsg = ee.Message;
				return false;
			}
		}

		/// <summary>
		/// ڑLZ
		/// </summary>
		/// <returns></returns>
		public bool Disconnect()
		{
			try
			{
				netStream.Close();
				tcpC.Close();
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// POPT[oɃR}h𑗐M
		/// </summary>
		/// <param name="command"></param>
		/// <returns></returns>
		public bool SendDataToServer(string command)
		{
			byte[] bb;
			bb = Encoding.ASCII.GetBytes(command + CRLF);
			try
			{
				netStream.Write(bb,0,bb.Length);
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// Ps̉񓚂M
		/// </summary>
		/// <returns></returns>
		public string GetLine()
		{
			try
			{
				StreamReader sReader = new StreamReader(netStream,Encoding.ASCII);
				return sReader.ReadLine();
			}
			catch
			{
				return null;
			}
		}

		/// <summary>
		/// s̉񓚂M
		/// </summary>
		/// <returns></returns>
		public string GetLines()
		{
			string ss = "";
			string msg = "";
			StreamReader sReader = new StreamReader(netStream,Encoding.ASCII);
			try
			{
				while((ss = sReader.ReadLine()) != null)
				{
					msg += (ss + CRLF);
					if(ss.Equals("."))
						break;
				}
			}
			catch
			{
				return null;
			}
			return msg;
		}
	}
}
